from paf_sapgui_component_session import active_session, window


def create(path_or_number: str | int, container: int = None, window_id: int = 0, click_it: bool = False):
    if isinstance(path_or_number, int):
        path_or_number = f'wnd[{window_id}]/tbar[{container}]/btn[{str(path_or_number)}]'
    local_element = active_session.session.findById(path_or_number)
    if click_it not in {False, None}:
        local_element.press()
    return local_element


def create_by_path(path, value=None, window_id=0):
    if value is not None:
        return click_by_path(path, window_id)
    path = window.check_id(path)
    return active_session.session.findById(path)


def green_tick(window_id=0):
    create(0, 0, window_id).press()


def execute(window_id=0):
    create(path_or_number=8, container=1, window_id=window_id).press()


def cancel(window_id=0):
    create(path_or_number=12, container=1, window_id=window_id).press()


def close(window_id=0):
    create(path_or_number=15, container=1, window_id=window_id).press()


def back(window_id=0):
    create(path_or_number=3, container=0, window_id=window_id).press()


def exists(path_or_number, container, window_id=0):
    try:
        create(path_or_number, container, window_id)
        return True
    except Exception as ex:
        print(ex)
        return False


def click_by_path(path: str, window_id: int = 0):
    path = window.check_id(path)
    local_button = active_session.session.findById(path)
    local_button.press()
    return local_button


def click(number, container, window_id=0):
    create(number, container, window_id).press()


def get_object(number, container, window_id=0):
    return create(number, container, window_id)


def save(window_id=0):
    active_session.session.findById(create(11, 0, window_id)).press()


def selection_options(window_id=0):
    create(2, 1, window_id).press()
